您的位置:首页 > 大数据 > 人工智能

hdu 2389 Rain on your Parade(最大匹配,Hopcroft-Karp算法模版)

2014-03-17 18:43 549 查看

Rain on your Parade

Time Limit: 6000/3000 MS (Java/Others) Memory Limit: 655350/165535 K (Java/Others)

Total Submission(s): 2458 Accepted Submission(s): 766



[align=left]Problem Description[/align]
You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just
as you had imagined. It could be the perfect end of a beautiful day.

But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence
they stand terrified when hearing the bad news.

You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just
like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.

Can you help your guests so that as many as possible find an umbrella before it starts to pour?

Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.

[align=left]Input[/align]
The input starts with a line containing a single integer, the number of test cases.

Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units
per minute (1 <= si <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated
by a space.

The absolute value of all coordinates is less than 10000.

[align=left]Output[/align]
For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to
rain. Terminate every test case with a blank line.

[align=left]Sample Input[/align]

2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4


[align=left]Sample Output[/align]

Scenario #1:
2

Scenario #2:
2
题意:求最大匹配。思路:Hopcroft-Karp算法
AC代码:[code]#include <iostream>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <cstdio>
#include <queue>
#include <stack>
#include <ctime>
#include <vector>
#include <algorithm>
#define ll long long
#define L(rt) (rt<<1)
#define R(rt)  (rt<<1|1)
#define eps 1e-6;
using namespace std;

const int INF = 1e9;
const int maxn = 3005;

struct node{
int x, y;
}p[maxn], u[maxn];
int s[maxn];
int n, m, t, dis;
int cx[maxn], cy[maxn], dx[maxn], dy[maxn];
bool G[maxn][maxn], vis[maxn];
bool ok(int a, int b){
int dis = (p[a].x - u[b].x) * (p[a].x - u[b].x) + (p[a].y - u[b].y) * (p[a].y - u[b].y);
if(dis <= t * t * s[a] * s[a]) return true;
return false;
}
bool bfs(){
queue<int> Q;
dis = INF;
memset(dx, -1, sizeof(dx));
memset(dy, -1, sizeof(dy));
for(int i = 0; i < n; i++)
{
if(cx[i] == -1)
{
Q.push(i);
dx[i] = 0;
}
}
while(!Q.empty())
{
int u = Q.front();
Q.pop();
if(dx[u] > dis) break;
for(int v = 0; v < m; v++)
{
if(G[u][v] && dy[v] == -1)
{
dy[v] = dx[u] + 1;
if(cy[v] == -1) dis = dy[v];
else
{
dx[cy[v]] = dy[v] + 1;
Q.push(cy[v]);
}
}
}
}
return dis != INF;
}
int dfs(int u){
for(int v = 0; v < m; v++)
if(!vis[v] && G[u][v] && dy[v] == dx[u] + 1)
{
vis[v] = true;
if(cy[v] != -1 && dy[v] == dis) continue;
if(cy[v] == -1 || dfs(cy[v]))
{
cy[v] = u;
cx[u] = v;
return 1;
}
}
return 0;
}
int MMG(){
int ans = 0;
memset(cx, -1, sizeof(cx));
memset(cy, -1, sizeof(cy));
while(bfs())
{
memset(vis, false, sizeof(vis));
for(int i = 0; i < n; i++)
if(cx[i] == -1) ans += dfs(i);
}
return ans;
}
int main()
{
int tt, ca = 0;
scanf("%d", &tt);
while(tt--)
{
scanf("%d", &t);
scanf("%d", &n);
for(int i = 0; i < n; i++)
scanf("%d%d%d", &p[i].x, &p[i].y, &s[i]);
scanf("%d", &m);
for(int i = 0; i < m; i++)
scanf("%d%d", &u[i].x, &u[i].y);
memset(G, false, sizeof(G));
for(int i = 0; i < n; i++)
for(int j = 0; j < m; j++)
if(ok(i, j))
{
G[i][j] = true;
}
printf("Scenario #%d:\n", ++ca);
printf("%d\n", MMG());
puts("");
}
return 0;
}


[/code]
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: